%global commit 302e4a93fb40cc48cdb97913dfcadff2809ef024

%global opt %(test -x %{_bindir}/ocamlopt && echo 1 || echo 0)
%global __provides_exclude_from ^%{_libdir}/ocaml/stublibs/.*\.so$

Name:           js-of-ocaml
Version:        2.4
Release:        8%{?dist}
Summary:        An OCaml to Javascript compiler

License:        LGPLv2+ with exceptions
URL:            http://ocsigen.org/js_of_ocaml
Source0:        https://github.com/ocsigen/js_of_ocaml/archive/%{commit}/js_of_ocaml-%{commit}.tar.gz

# Allow examples to be built with the distro packaged js-of-ocaml
Source1:        Makefile.common.js-of-ocaml.examples

# Upstream patch to fix build against OCaml 4.02.
Patch1:         0001-Compiler-fix-with-latest-4.02.patch

BuildRequires:  ocaml
BuildRequires:  ocaml-findlib-devel
BuildRequires:  ocaml-ocamldoc
BuildRequires:  ocaml-camlp4-devel
BuildRequires:  ocaml-lwt >= 2.3.0
BuildRequires:  ocaml-menhir-devel
BuildRequires:  chrpath

%description
js_of_ocaml is a compiler of OCaml byte-code to JavaScript.
It makes it possible to run OCaml programs in a web browser.
Its key features are the following:
 * the whole language, and most of the standard library are
   supported;
 * the generated code can be used with any web server and browser;
 * you can use a standard installation of OCaml to compile your
   programs. In particular, you do not have to recompile a library to
   use it with Js_of_ocaml. You just have to link your program with a
   specific library to interface with the browser APIs.
 
%package        doc
Summary:        User manual and other documentation for %{name}
Group:          Development/Libraries
BuildArch:      noarch
License:        (LGPLv2+ with exceptions) and GPLv2+ and WTFPL

%description    doc
The %{name}-doc package contains the user manual, API
reference and examples for %{name}.
 
%prep
%setup -q -n js_of_ocaml-%{commit}

%patch1 -p1


%build
# Hack to enable debug symbol generation.
find -name Makefile | xargs perl -pi.bak -e 's/ocamlopt/ocamlopt -g/'

make

%install
export DESTDIR=$RPM_BUILD_ROOT
export OCAMLFIND_DESTDIR=$RPM_BUILD_ROOT%{_libdir}/ocaml
mkdir -p $OCAMLFIND_DESTDIR $OCAMLFIND_DESTDIR/stublibs
D=$RPM_BUILD_ROOT%{_libdir}/ocaml/js_of_ocaml
mkdir -p $D
cp -p lib/META \
    lib/*.{cmi,cma,a,mli} \
    lib/syntax/pa_js.cmo \
    runtime/runtime.js \
    $D
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p compiler/js_of_ocaml $RPM_BUILD_ROOT%{_bindir}/
cp -p lib/dlljs_of_ocaml.so $OCAMLFIND_DESTDIR/stublibs/

chrpath --delete $OCAMLFIND_DESTDIR/stublibs/dll*.so


# docs
find examples '(' -name '*.cmi' -or -name '*.cmo' -or -name '*.byte' -or -name '.depend' ')' -exec rm '{}' ';'
# Replacing Makefile.common allows the user to build the examples
cp -p %{SOURCE1} examples/Makefile.common

%files
%doc LICENSE
%{_libdir}/ocaml/js_of_ocaml/
%{_libdir}/ocaml/stublibs/*.so
%{_bindir}/js_of_ocaml

%files doc
%doc LICENSE README.md examples doc/api/html doc/manual


%changelog
* Wed Jun 24 2015 Richard W.M. Jones <rjones@redhat.com> - 2.4-8
- ocaml-4.02.2 final rebuild.

* Thu Jun 18 2015 Richard W.M. Jones <rjones@redhat.com> - 2.4-7
- ocaml-4.02.2 rebuild.

* Wed Jun 17 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 2.4-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Tue Feb 17 2015 Richard W.M. Jones <rjones@redhat.com> - 2.4-5
- ocaml-4.02.1 rebuild.

* Sun Aug 31 2014 Richard W.M. Jones <rjones@redhat.com> - 2.4-4
- ocaml-4.02.0 final rebuild.

* Sat Aug 23 2014 Richard W.M. Jones <rjones@redhat.com> - 2.4-3
- ocaml-4.02.0+rc1 rebuild.

* Tue Aug 19 2014 Richard W.M. Jones <rjones@redhat.com> - 2.4-2
- +BR menhir.
- Add upstream patch to fix build against OCaml 4.02.

* Mon Aug 18 2014 Scott Tsai <scottt.tw@gmail.com> 2.4-1
- New upstream release 2.4 

* Sat Aug 16 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.3.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Apr 15 2014 Richard W.M. Jones <rjones@redhat.com> - 1.3.2-3
- Remove ocaml_arches macro (RHBZ#1087794).

* Thu Sep 19 2013 Richard W.M. Jones <rjones@redhat.com> - 1.3.2-2
- OCaml 4.01.0 rebuild.
- Enable debuginfo.
- Remove strip & prelink hacks - not needed on recent OCaml.

* Sat Sep 14 2013 Scott Tsai <scottt.tw@gmail.com> 1.3.2-1
- Upstream 1.3.2

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Fri Dec 14 2012 Richard W.M. Jones <rjones@redhat.com> - 1.2-2
- Rebuild for OCaml 4.00.1.

* Mon Nov 26 2012 Scott Tsai <scottt.tw@gmail.com> 1.2-1
- Upstream 1.2

* Fri Jun 15 2012 Scott Tsai <scottt.tw@gmail.com> 1.0.9-4
- Rebuild for OCaml 4.00.0

* Sun Jan 08 2012 Richard W.M. Jones <rjones@redhat.com> - 1.0.9-3
- Rebuild for OCaml 3.12.1.

* Sun Jan 08 2012 <scottt.tw@gmail.com> 1.0.9-2
- Rebuild for OCaml 3.12.1.

* Tue Dec 13 2011 Scott Tsai <scottt.tw@gmail.com> 1.0.9-1
- Initial RPM release.
